# Note

A note represents some value of a particular asset attached to an owner's address (related to a shielded account) who has the authority to spend it. A user can have zero or more notes in their shielded account. The asset balance of a shielded account is simply the sum of the values of all notes of that asset.

In our protocol, a Note is a tuple of multiple items:

* `assetId`: Identifier for the asset (ETH, WBTC, MATIC, etc.), this note represents the value of.
* `value`: Value or amount the note represents.
* `leafIndex`: The leaf index of the commitment merkle tree where this note will be inserted.
* `blinding`: A random blinding factor.
* `rootAddress`: The root address of a user having the authority to spend it.
* `revoker`: The chosen revoker's public key point.

```typescript

 return new Note({
      assetId,
      value,
      leafIndex,
      blinding,
      rootAddress: account.rootAddress,
      revoker: tx.revoker,
    });

```

All the notes that have ever existed have their commitments stored in a data structure called a [Merkle tree](/technical-implementation/core-architecture/merkle-tree.md). This is essential for bookkeeping, as will be clear in the next sections.

The so-called `commitment` of a note is defined Poseidon hash of:

```typescript
commitment = H(assetId, owner, value)
```

where `owner` is the [blinded address](/technical-implementation/shielded-address.md#blinded-address) generated using the `blinding` of the note:

`owner = H(rootAddress, revoker.x, revoker.y, blinding)`


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.veilnyx.com/technical-implementation/core-architecture/note.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
